/////////////////////////////////////////////////////////////////////////
//Kapitel Bibliotheken
//Beispiel für das Laden und Abspielen eines mp3-Streams im Internet
/////////////////////////////////////////////////////////////////////////
import ddf.minim.*;

Minim minim;
AudioPlayer radio;
AudioRecorder recorder;
float faktor;

void setup()
{
  size(512, 220);
  textSize(24);
  faktor = 55;
  minim = new Minim(this);
  //Es gibt zahllose Internet-Radio-Streams.
  //Hier zum Beispiel wird man fündig:
  //https://wiki.ubuntuusers.de/Internetradio/Stationen/
  //oder bei  http://www.radio-browser.info/gui/#/
  //SWR2:  http://swr-swr2-live.cast.addradio.de/swr/swr2/live/mp3/256/stream.mp3
  radio= minim.loadFile("http://jazzblues.ice.infomaniak.ch/jazzblues-high.mp3", 2048);
  recorder = minim.createRecorder(radio, radio.getMetaData().title()+"radio.wav", true);
  radio.play();
}

void draw(){
  background(0);
  fill(255);
  stroke(255);
  // zeichnen der Wellen von linkem und rechtem Kanal
  // left.get() und right.get() liegen zwischen -1 and 1.
  // Um sichtbar zu sein, müssen beide Werte mit einem geeigneten
  // Faktor mulitipliziert werden
  for(int i = 0; i < radio.bufferSize()-1; i++)
  {
    float x1 = map(i, 0, radio.bufferSize(), 0, width);
    float x2 = map(i+1, 0, radio.bufferSize(), 0, width);
    line(x1, 50 + radio.left.get(i)*faktor, x2, 50 + radio.left.get(i+1)*faktor);
    line(x1, 150 + radio.right.get(i)*faktor, x2, 150 + radio.right.get(i+1)*faktor);
  }
}

void keyReleased(){
  // mit "r" Aufnahme starten
  if ( key == 'r' ) {
    if (recorder.isRecording()) recorder.endRecord();
    else {
    // Dateiname für Aufnahme festlegen
    recorder = minim.createRecorder(radio, radio.getMetaData().title()+"radio.wav", true);
    recorder.beginRecord();
    }
  }
  // mit "s" Aufnahme gespeichern
  if ( key == 's' ) {
    recorder.endRecord();
    recorder.save();
    println("Speichervorgang erfolgreich.");
  }
}

void stop()
{
  radio.close();
  minim.stop();
  super.stop();
}